// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#include "targetver.h"

#include <stdio.h>
#include <tchar.h>

#include <Windows.h>

#include <stdint.h>
//typedef int int32_t;
//typedef unsigned uint32_t;

typedef float(*Transform)(float);

void ExhaustiveTest(uint32_t start, uint32_t stop, Transform TestFunc,
	Transform RefFunc, const char* desc);

/* See

http://randomascii.wordpress.com/2012/01/11/tricks-with-the-floating-point-format/

for the potential portability problems with the union and bit-fields below.
*/

union Float_t
{
	Float_t(float num = 0.0f) : f(num) {}
	// Portable extraction of components.
	bool Negative() const { return (i >> 31) != 0; }
	int32_t RawMantissa() const { return i & ((1 << 23) - 1); }
	int32_t RawExponent() const { return (i >> 23) & 0xFF; }

	int32_t i;
	float f;
#ifdef _DEBUG
	struct
	{   // Bitfields for exploration. Do not use in production code.
		uint32_t mantissa : 23;
		uint32_t exponent : 8;
		uint32_t sign : 1;
	} parts;
#endif
};

// Simple timing class.
class TimeIt
{
public:
	TimeIt()
		: m_startTick(GetTickCount())
	{
	}
	~TimeIt()
	{
		DWORD elapsed = GetTickCount() - m_startTick;
		printf("%Took %1.2f s\n", elapsed * 0.001);
	}
	DWORD m_startTick;
};
